/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import java.util.Locale;

import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumChestCardiacSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumDICOMSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_CTAndMRAnatomyImaged;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_CardiacVolumeMeasurements;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_EDVolume;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_EDVolume;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_ESVolume;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_CardiacVolumeMeasurements;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;
import cdac.medinfo.sdk.dcm30_04.utils.ResourceBundleWrapper;


/**
 * This class represents CardiacVolumeMeasurements CID3835
 */
public class CardiacVolumeMeasurements_CID3835 {

	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	
	/**
	 * Object of CathComplications_CID3755
	 */
	private EDVolume_CID3468 objEDVolumeCID3468;
	
	/**
	 * Object of CathComplications_CID3755
	 */
	private ESVolume_CID3469 objESVolumeCID3469;
	/**
	 * Instantiates a new CardiacVolumeMeasurements_CID3835 Template 
	 */
	public CardiacVolumeMeasurements_CID3835()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumCardiacVolumeMeasurements Object of EnumCM_CardiacVolumeMeasurements represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_CardiacVolumeMeasurements enumCardiacVolumeMeasurements)
	{
		switch(enumCardiacVolumeMeasurements)
		{
		case STROKE_VOLUME: this.strCodeValue = EnumCV_CardiacVolumeMeasurements.STROKE_VOLUME_F_32120.getValue();break;

		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumCardiacVolumeMeasurements Object of EnumCM_CardiacVolumeMeasurements represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_CardiacVolumeMeasurements enumCardiacVolumeMeasurements)
	{
		switch(enumCardiacVolumeMeasurements)
		{
		case STROKE_VOLUME: this.strSNOMEDCTID = EnumChestCardiacSNOMEDMap.STROKE_VOLUME.getSNOMEDCTID();break;
		
		}
	}

	/**
	 * Sets the value for CardiacVolumeMeasurements
	 * @param enumCardiacVolumeMeasurements Object of EnumCM_CardiacVolumeMeasurements.
	 */
	public void setCardiacVolumeMeasurements(Enum enumValue)
	{
		
		if (enumValue instanceof EnumCM_CardiacVolumeMeasurements) 
		{
			/**
			 * Casting EnumValue to required Enum.
			 */
			EnumCM_CardiacVolumeMeasurements enumCardiacVolumeMeasurements = (EnumCM_CardiacVolumeMeasurements)enumValue;
			/**
			 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
			 * sets the Code Value according to Code Meaning.
			 */
			this.strCodeMeaning = enumCardiacVolumeMeasurements.getValue();
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
			/**
			 * set code Value
			 */
			setCodeValue(enumCardiacVolumeMeasurements);

			/**
			 * set SNOMED-CT ID
			 */
			setSNOMEDCTID(enumCardiacVolumeMeasurements);
		}
		else if(enumValue instanceof EnumCM_EDVolume)
		{
			/**
			 * Casting EnumValue to required Enum.
			 */
			EnumCM_EDVolume new_enumEDVolume = (EnumCM_EDVolume) enumValue;
			
			/**
			 * Creating object of require CID with respect to enum and setting value accordingly.
			 */
			if(null== this.objEDVolumeCID3468)
				this.objEDVolumeCID3468 = new EDVolume_CID3468();
			this.objEDVolumeCID3468.setEDVolume(new_enumEDVolume);
			
			/**
			 * Retrieving attributes and setting it to member variables. 
			 */
			this.strCodeMeaning = objEDVolumeCID3468.getCodeMeaning();
			this.strCodeValue = objEDVolumeCID3468.getCodeValue();
			this.strCodingSchemeDesignator = objEDVolumeCID3468.getCodingSchemeDesignator();
		}
		else if(enumValue instanceof EnumCM_ESVolume)
		{
			/**
			 * Casting EnumValue to required Enum.
			 */
			EnumCM_ESVolume new_enumESVolume = (EnumCM_ESVolume) enumValue;
			
			/**
			 * Creating object of require CID with respect to enum and setting value accordingly.
			 */
			if(null== this.objESVolumeCID3469)
				this.objESVolumeCID3469 = new ESVolume_CID3469();
			this.objESVolumeCID3469.setESVolume(new_enumESVolume);
			
			/**
			 * Retrieving attributes and setting it to member variables. 
			 */
			this.strCodeMeaning = objESVolumeCID3469.getCodeMeaning();
			this.strCodeValue = objESVolumeCID3469.getCodeValue();
			this.strCodingSchemeDesignator = objESVolumeCID3469.getCodingSchemeDesignator();
		}
		else
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger objDicomLogger = DicomLogger.getLogger();
				objDicomLogger.log(ResourceBundleWrapper.getValue("warning","InvalidEnumeratedValue",new Locale(DicomConfig.createInstance().getLocale())));
			}
		}
	}
}
